//
//  BallLayer.m
//  PeerPong
//
//  Created by Volker Tietz on 11/29/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "BallLayer.h"

@class PeerPongGameplay;

@implementation BallLayer

@synthesize fixture;

- (id)init {
    self = [super init];
    if (self) {
        gameplay = [PeerPongGameplay sharedInstance];
        [self addBall];
    }
    return self;
}

-(void)addBall {
    ball = [CCSprite spriteWithFile:@"ball_40.png" rect:CGRectMake(0, 0, 40, 40)];
    ball.tag = gameplay.ballTag;
    ball.position = ccp(gameplay.windowSize.width/2, gameplay.windowSize.height/2);
    [self addChild:ball];
    
    // Create ball body 
    b2BodyDef bodyDef;
    bodyDef.type = b2_dynamicBody;
    bodyDef.position.Set(ball.position.x/gameplay.PTM_RATIO, ball.position.y/gameplay.PTM_RATIO);
    bodyDef.userData = ball;
    body = gameplay.world->CreateBody(&bodyDef);
    
    // Create circle shape
    b2CircleShape circle;
    circle.m_radius = 26.0/gameplay.PTM_RATIO;
    
    // Create shape definition and add to body
    b2FixtureDef shapeDef;
    shapeDef.shape = &circle;
    shapeDef.density = 1.0f;
    shapeDef.friction = 0.f;
    shapeDef.restitution = 1.0f;
    self.fixture = body->CreateFixture(&shapeDef);
    
    // Define impulse for ball
    int signatures[2] = {-1, 1};
    int randomSign1 = arc4random() % 2;
    int randomSign2 = arc4random() % 2;
    b2Vec2 force = b2Vec2(signatures[randomSign1] * 20, signatures[randomSign2] * 20);
    body->ApplyLinearImpulse(force, bodyDef.position);
}

-(void)removeBall {
    body->DestroyFixture(self.fixture);
    gameplay.world->DestroyBody(body);
    [self removeChild:ball cleanup:YES];
}
@end
