//
//  GameBoxLayer.h
//  PeerPong
//
//  Created by Volker Tietz on 12/3/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "cocos2d.h"
#import "Box2D.h"

@class PeerPongGameplay;
@class PeerPongPlayer;

@interface GameBoxLayer : CCLayer {
    b2PolygonShape groundBox;
    b2FixtureDef groundBoxDef;
    
    b2Vec2 bottomLeftCorner;
    b2Vec2 bottomRightCorner;
    b2Vec2 topLeftCorner;
    b2Vec2 topRightCorner;
    
    CCSprite *leftBar;
    b2Fixture *leftEdge;
    
    CCSprite *topBar;
    b2Fixture *topEdge;
    
    CCSprite *rightBar;
    b2Fixture *rightEdge;
    
    b2Fixture *bottomEdge;
    
    PeerPongGameplay *gameplay;
}

@property (nonatomic) b2Fixture *leftEdge;
@property (nonatomic) b2Fixture *topEdge;
@property (nonatomic) b2Fixture *rightEdge;
@property (nonatomic) b2Fixture *bottomEdge;

-(void)createGameBox;
-(void)addEdgeAndBarForSlotNumber:(int)aSlotNumber;
-(void)removeEdgeAndBarForPlayer:(PeerPongPlayer *)aPlayer;


@end
