//
//  WaitingForPlayersScene.h
//  PeerPong
//
//  Created by Volker Tietz on 11/23/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "cocos2d.h"
#import "MyContactListener.h"
@class BackgroundLayer;
@class WelcomeLayer;
@class PaddlesLayer;
@class BallLayer;
@class GameBoxLayer;
@class PeerPongGameplay;
@class PeerPongPlayer;
@class QueueLayer;
@class MessageLayer;


@interface MainScene : CCScene {
    BackgroundLayer *backgroundLayer;
    WelcomeLayer    *welcomeLayer;
    PaddlesLayer    *paddlesLayer;
    BallLayer       *ballLayer;
    QueueLayer      *queueLayer;
    GameBoxLayer    *gameBoxLayer;
    MessageLayer    *messageLayer;
    
    PeerPongGameplay *gameplay;
    
    MyContactListener *contactListener;
    int soundDelayFrames;
}

-(void)updatePaddles;
-(void)addPaddleForPlayer:(PeerPongPlayer *)aPlayer;
-(void)removePaddleForPlayer:(PeerPongPlayer *)aPlayer;

-(void)addBallLayer;
-(void)removeBallLayer;

-(void)addWelcomeLayer;
-(void)removeWelcomeLayer;

-(void)lastPlayerLeavesGame;

-(void)reinitGame;
-(void)endGame;

-(void)updateQueue;

-(void)popMessage:(NSString*)aMessage;

-(void)tick:(ccTime) dt;

@end
