//
//  PeerPongPaddle.h
//  PeerPong
//
//  Created by Volker Tietz on 12/3/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Box2D.h"
#import "cocos2d.h"
@class PeerPongGameplay;
@class PeerPongPlayer;

@interface PeerPongPaddle : NSObject {
    CCSprite *sprite;
    CCLabelTTF *playerName;
    CCLabelTTF *playerNameShadow;
    
    CCLabelTTF *playerLivesLeft;
    
    b2Body *body;
    b2Fixture *fixture;    
    b2Joint *joint;
    b2MouseJoint *mouseJoint;
    
    PeerPongPlayer *player;
    
    float paddlePosition;
    
    NSMutableArray *spriteFiles;
    NSMutableArray *paddlePositions;
    
    float boxWidthForPaddle;
    float boxHeightForPaddle;
    
    PeerPongGameplay *gameplay;
}

@property (nonatomic,retain) CCSprite *sprite;

@property (nonatomic,retain) CCLabelTTF *playerName;
@property (nonatomic,retain) CCLabelTTF *playerNameShadow;

@property (nonatomic,retain) CCLabelTTF *playerLivesLeft;

-(id)initWithPlayer:(PeerPongPlayer *)aPlayer;

-(void)updateLivesLeftLabel;

-(void)addPhysics;
-(void)removePhysics;

-(float)getTranslatedOffsetForX;
-(float)getTranslatedOffsetForY;

-(b2Vec2)getLocation;
-(b2Vec2)getAxis;

-(BOOL)isHorizontal;
-(void)update;

@end
