//
//  PeerPongServer.m
//  PeerPong
//
//  Created by Volker Tietz on 11/22/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "PeerPongServer.h"
#import "UnicornServer.h"
#import "CWHessianArchiver.h"
#import "PeerPongGameplay.h"
#import "LostLife.h"

@implementation PeerPongServer 

@synthesize server;
@synthesize gamePlay;

-(void)start {
    if(!self.server) {
        self.server = [[[UnicornServer alloc] initOnPort:@"9999" withDelegate:self andName:@"PeerPongServer"] autorelease];   
    }
    
    // register protocols to receive
    [self.server registerProtocol:@"Command"];
    [self.server registerProtocol:@"Hello"];
    [self.server registerProtocol:@"AreYouReady"];
    [self.server registerProtocol:@"IAmReady"];
    [self.server registerProtocol:@"GoodBye"];
    [self.server registerProtocol:@"LostLife"];
    
    [CWHessianArchiver setClassName:@"de.hdmstuttgart.de.mi.csm.mobileapplications.peerpong.interfaces.AreYouReady" forProtocol:@protocol(AreYouReady)];
    [CWHessianArchiver setClassName:@"de.hdmstuttgart.de.mi.csm.mobileapplications.peerpong.interfaces.AreYouReady" forClass:[AreYouReady class]];
    [CWHessianArchiver setClassName:@"de.hdmstuttgart.de.mi.csm.mobileapplications.peerpong.interfaces.LostLife" forProtocol:@protocol(LostLife)];
    [CWHessianArchiver setClassName:@"de.hdmstuttgart.de.mi.csm.mobileapplications.peerpong.interfaces.LostLife" forClass:[LostLife class]];

    [self.server start];
}

-(void)stop {
    [self.server stop];
}

-(void)didReceiveObject:(id)object fromClient:(GCDAsyncSocket *)client {
    if([object isKindOfClass:[Command class]]) {
        Command *command = (Command*)object;
        [self.gamePlay receivedCommand:command fromClient:client];
    } else if([object isKindOfClass:[Hello class]]) {
        Hello *hello = (Hello *) object;
        [self.gamePlay receivedHello:hello fromClient:client];
    } else if([object isKindOfClass:[IAmReady class]]) {
        IAmReady *iAmReady = (IAmReady *) object;
        [self.gamePlay receivedIAmReadyForSlot:iAmReady.slot fromClient:client];
    }
}

-(void)didDisconnectFromClient:(GCDAsyncSocket *)client {
    [self.gamePlay receivedDisconnectFromClient:client];
}

-(void)didReceiveError:(NSError*)error {
    NSLog(@"error! %@", error);
}

-(void)sendObject:(id)object toClient:(GCDAsyncSocket *)client {
    [self.server respondWithObject:object toClient:client];
}

-(void)dealloc {
    self.server = nil;
    [super dealloc];
}

@end
