//
//  QueueLayer.m
//  PeerPong
//
//  Created by Volker Tietz on 12/6/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "QueueLayer.h"
#import "PeerPongGameplay.h"
#import "PeerPongPlayer.h"
#import "PeerPongQueueItem.h"

@implementation QueueLayer

@synthesize queueItems;

- (id)init {
    self = [super init];
    if (self) {
        gameplay = [PeerPongGameplay sharedInstance];
        size = gameplay.windowSize;
        
        self.queueItems = [NSMutableArray arrayWithCapacity:4];
        
        for (int i = 0; i < 4; i++) {
            PeerPongQueueItem *item = [[PeerPongQueueItem alloc] initWithQueueSlot:i];
            [self.queueItems addObject:item];
        }
    }
    return self;
}

-(void)update {
    // Remove all items that will not be used
    for (int i = [gameplay.playerQueue count]; i < 4; i++) {
        if ([self getChildByTag:gameplay.queueSpriteTag+i]) {
            [self removeChildByTag:gameplay.queueSpriteTag+i cleanup:YES];
        }
    }
    
    // Add items to layer if they don't already exist
    for (int i = 0; i < [self.queueItems count]; i++) {
        if([gameplay.playerQueue count] > i) {
            PeerPongPlayer *player = [gameplay.playerQueue objectAtIndex:i];
            PeerPongQueueItem *item = [self.queueItems objectAtIndex:i];
            item.label.string = player.name;
            if (![self getChildByTag:gameplay.queueSpriteTag+i]) {
                [self addChild:item.sprite z:1 tag:gameplay.queueSpriteTag+i];
            }
        }
    }
}

- (void)dealloc {
    
    [super dealloc];
}

@end
